package OffensiveWordChecker;

import com.keyoti.rapidSpell.AdvancedTextBoundary;
import com.keyoti.rapidSpell.BadWord;
import com.keyoti.rapidSpell.CheckerEngineAdapter;
import java.util.HashMap;

import java.util.Vector;


public class FlandersParser extends CheckerEngineAdapter implements com.keyoti.rapidSpell.ICheckerEngine {

	HashMap dictionary = new HashMap();
	String theText, suggestion = null;
	
	
	int wordStart, wordEnd;
	
	AdvancedTextBoundary wordIterator = new AdvancedTextBoundary();

	public FlandersParser(){
		//load dictionary of flanderisms, a real offensive word parser would of course
		//have a list of swears here.
		dictionary.put("gosh", "****");
		dictionary.put("darn", "****");
		dictionary.put("co-winky-dink", "**-*****-****");		
		dictionary.put("doodle", "*****");
		dictionary.put("neighboreeny", "neighbor");
		dictionary.put("hi-diddly-ho", "hello");			
		
	}

	public void check(String text){
		theText = text;
		wordIterator.setText(text);
		
	}





	public BadWord nextBadWord(){
		String nextWord = GetNextWord();
		int currentBadWordStart = -1;
		int currentBadWordEnd = -1;
		if (nextWord==null) return null;
		else 
		{

			//see if next word is bad or if we are to ignore this word, if not scan for next bad word 
			while(!dictionary.containsKey(nextWord))
			{
				nextWord = GetNextWord();
				
				//ran out of words
				if (nextWord==null) return null;


				
			}
			currentBadWordStart = wordStart;
			currentBadWordEnd = wordEnd;
			if (dictionary.containsKey(nextWord))
				suggestion = (String) dictionary.get(nextWord);	
		}
		return new com.keyoti.rapidSpell.BadWord(nextWord,currentBadWordStart,currentBadWordEnd);
	}

	

	/// Returns the next word in the text.
	/// <returns>String the next word in the text</returns>
	String GetNextWord() 
	{

		wordStart = wordEnd;
		if(wordEnd < wordIterator.last()) 
		{
			wordEnd = wordIterator.following( wordEnd );

			if(wordEnd-wordStart <= 0 
				|| !Character.isLetterOrDigit( theText.charAt(wordStart) ) 
				)
			{

				//ignore and move on to next word
				return GetNextWord();
			}

			//return as a word
			return theText.toString().substring(wordStart, wordEnd );
		} 
		else 
		{
			return null;
		}
	}


	public Vector findSuggestions(){
		Vector s = new Vector();
		if (suggestion != null) s.add(suggestion);
		return s;
	}


	
	
	//@Override
	public boolean getAllowAnyCase() {
		// TODO Auto-generated method stub
		return false;
	}

	//@Override
	public boolean getIgnoreWordsWithDigits() {
		// TODO Auto-generated method stub
		return false;
	}

	//@Override
	public boolean getWarnDuplicates() {
		// TODO Auto-generated method stub
		return false;
	}

	//@Override
	public void setAllowAnyCase(boolean arg0) {
		// TODO Auto-generated method stub
		
	}

	//@Override
	public void setIgnoreWordsWithDigits(boolean arg0) {
		// TODO Auto-generated method stub
		
	}

	//@Override
	public void setMaximumAnagramLength(int arg0) {
		// TODO Auto-generated method stub
		
	}

	//@Override
	public void setWarnDuplicates(boolean arg0) {
		// TODO Auto-generated method stub
		
	}

}
